/*
  Filename: states.cc
  keeps list of states
  acts on states
*/

#include "../std.h"
#include "../run/run.h"
#include "../files/info_types.h"
#include "../files/info_files.h"
// #include "users.h"
#include "job.h"


JobDescription::JobDescription(void) {
  job_state=JOB_STATE_UNDEFINED;
  child=NULL;
  local=NULL;
  job_uid=0; job_gid=0;
}

JobDescription::JobDescription(const JobDescription &job) {
  job_state=job.job_state;
  job_id=job.job_id;
  session_dir=job.session_dir;
  failure_reason=job.failure_reason;
  keep_finished=job.keep_finished;
  child=NULL;
  local=job.local;
  job_uid=job.job_uid; job_gid=job.job_gid;
}

JobDescription::JobDescription(const JobId &id,const string &dir,job_state_t state) {
  job_state=state;
  job_id=id;
  session_dir=dir;
  keep_finished=DEFAULT_KEEP_FINISHED;
  child=NULL;
  local=NULL;
  job_uid=0; job_gid=0;
}

JobDescription::~JobDescription(void){
 /* child is not destroyed here */
}

bool JobDescription::GetLocalDescription(const JobUser &user) {
  if(local) return true;
  JobLocalDescription* job_desc;
  job_desc=new JobLocalDescription;
  if(!job_local_read_file(job_id,user,*job_desc)) {
    delete job_desc;
    return false;
  };
  local=job_desc;
  return true;
}

