/* write essential inforamtion about job started/finished */
#ifndef __GM_JOB_LOG_H__
#define __GM_JOB_LOG_H__

#include <string>
#include <fstream>
#include "escaped.h"
#include "../jobs/job.h"
#include "../jobs/users.h"
#include "../run/run.h"

/*
  Put short information into log when every job starts/finishes.
*/
class JobLog {
 private:
  string filename;
  string url;
  string cluster_name;
  RunElement *proc;
  time_t last_run;
  bool open_stream(ofstream &o);
 public:
  JobLog(void);
  JobLog(const char* fname);
  ~JobLog(void);
  /* chose name of log file */
  void SetOutput(const char* fname);
  /* log job start information */
  bool start_info(JobDescription &job,const JobUser &user);
  /* log job finish iformation */
  bool finish_info(JobDescription &job,const JobUser &user);
  static bool read_info(fstream &i,bool &processed,bool &jobstart,struct tm &t,JobId &jobid,JobLocalDescription &job_desc,string &failure);
  bool is_reporting(void) { return (url.length() > 0); };
  bool RunReporter(JobUsers& users);
  bool SetReporter(const char* destination,const char* name = NULL);
  bool make_file(const JobDescription &job,JobUser &user);
};

#endif
