#include "std.h"

#include <iostream>
#include <string>
#include <globus_common.h>
#include <globus_rsl.h>
#include <globus_replica_catalog.h>
#include <globus_ftp_client.h>
#include <globus_gass_transfer.h>

#include "ngcommon.h"


int main (int argc, char ** argv) {

  globus_module_activate (GLOBUS_COMMON_MODULE);
  globus_module_activate (GLOBUS_RSL_MODULE);
  globus_module_activate (GLOBUS_REPLICA_CATALOG_MODULE);
  globus_module_activate (GLOBUS_FTP_CLIENT_MODULE);
  globus_module_activate (GLOBUS_GASS_TRANSFER_MODULE);

  string progname = argv[0];
  int pos = progname.rfind('/');
  if (pos != string::npos) {
    progname = progname.substr (pos + 1);
    // free (argv[0]);
    argv[0] = strdup (progname.c_str());
  }

  int retval = 0;

  if (progname == "ngsub")
    retval = ngsub (argc, argv);
  else if (progname == "ngstat")
    retval = ngstat (argc, argv);
  else if (progname == "ngkill")
    retval = ngkill (argc, argv);
  else if (progname == "ngget")
    retval = ngget (argc, argv);
  else if (progname == "ngclean")
    retval = ngclean (argc, argv);
  else if (progname == "ngsync")
    retval = ngsync (argc, argv);
  else if (progname == "ngcat")
    retval = ngcat (argc, argv);
  else if (progname == "ngrenew")
    retval = ngrenew (argc, argv);
  else {
    cerr << "Unknown program name: " << progname << endl;
    retval = 1;
  }

  globus_module_deactivate (GLOBUS_GASS_TRANSFER_MODULE);
  globus_module_deactivate (GLOBUS_FTP_CLIENT_MODULE);
  globus_module_deactivate (GLOBUS_REPLICA_CATALOG_MODULE);
  globus_module_deactivate (GLOBUS_RSL_MODULE);
  globus_module_deactivate (GLOBUS_COMMON_MODULE);

  return retval;
}
